/*
 * basic transfomrations test set
 *
 */
#include <tut.h>

#include "Vectors/BasicTransforms.hpp"

namespace Vectors
{

struct BasicTransformsTestClass
{
};

} // namespace Vectors


namespace tut
{
typedef Vectors::BasicTransformsTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Vectors/BasicTransforms");
}


using namespace Vectors;
const double eps = 0.001;

namespace tut
{

// make point from vector and vice versa
template<>
template<>
void testObj::test<1>(void)
{
  const Point2DCont  p=makePoint(1.0, 2.0);
  const Vector2DCont v=Vector2DCont( makePoint(0.0, 0.0), p );
  ensure( "vector2point() failed", p==vector2point(v) );
  ensure( "point2vector() failed", v==point2vector(p) );
}

// move point by some vector
template<>
template<>
void testObj::test<2>(void)
{
  const Point2DDisc  pIn =makePoint(2, 5);
  const Vector2DDisc vMov=point2vector( makePoint(-1, -3) );
  const Point2DDisc  pOut=movePointByVector(pIn, vMov);
  ensure( pOut[0]==1 && pOut[1]==2 );
}

} // namespace tut

