/*
 * Exception.hpp
 *
 * everything within this namespace should use this.
 *
 */
#ifndef INCLUDE_VECTORS_EXCEPTION_HPP_FILE
#define INCLUDE_VECTORS_EXCEPTION_HPP_FILE

/* public header */

#include <string>
#include <exception>


namespace Vectors
{


class Exception: std::exception
{
public:
  Exception(const std::string& msg):
                _msg(msg)
  {
  }

  Exception(const char msg[]):
                _msg(msg)
  {
  }

  virtual ~Exception(void) throw()
  {
  }

  const std::string& whatAsStr(void) const
  {
    return _msg;
  }

  virtual const char *what(void) const throw()
  {
    return _msg.c_str();
  }

private:
  std::string _msg;
}; // class Exception


}; // namespace Vectors


#endif

