/*
 * some example test set for test application.
 *
 */
#include <math.h>
#include <tut.h>

#include "Vectors/Line.hpp"

namespace Vectors
{

struct LineTestClass
{
  LineTestClass(void):
    _p1( makePoint(3.0, 1.0) ),
    _p2( makePoint(7.0, 5.0) )
  {
  }

  Point2DCont _p1;
  Point2DCont _p2;
};

} // namespace Vectors

static const double eps=0.001;

namespace tut
{
typedef Vectors::LineTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Vectors/Line");
}


using namespace Vectors;

namespace tut
{

// test basic constructor from 2 points
// and from() to()
template<>
template<>
void testObj::test<1>(void)
{
  Line2DCont l(_p1, _p2);
  ensure( l.from()==_p1 && l.to()==_p2 );
}

// test constructor for point + vector
template<>
template<>
void testObj::test<2>(void)
{
  Vector2DCont v=point2vector( makePoint(6.0, 2.0) );
  Line2DCont   l(_p1, v);
  ensure( l.from()==_p1 );
  ensure( l.to()  ==makePoint( _p1[0]+v[0], _p1[1]+v[1] ) );
}

// test length
template<>
template<>
void testObj::test<3>(void)
{
  Line2DCont l(_p1, _p2);
  ensure( fabs( l.length()-5.65685 )<eps );
}

// test (in)equality operators
template<>
template<>
void testObj::test<4>(void)
{
  Line2DCont l1(_p1, _p2);
  Line2DCont l2=l1;
  Line2DCont l3(_p1, makePoint(131.76054, -2342.2341) );
  ensure( l1==l2 );
  ensure( l1!=l3 );
}

} // namespace tut

