/*
 * main.t.cpp
 *
 * TUT main test file for library/application.
 * this is slightly reworked exmaple testapp main
 * from TUT home page.
 *
 */
#include <tut.h>
#include <tut_reporter.h>
#include <iostream>
#include <assert.h>


using std::exception;
using std::cerr;
using std::endl;


namespace tut
{
test_runner_singleton runner;
}


int main(const int argc, const char *const *const argv)
{
  assert(argc==1);  // no parameters are expected
  try
  {
    tut::reporter reporter;
    tut::runner.get().set_callback(&reporter);

    tut::runner.get().run_tests();
  }
  catch(const std::exception &ex)
  {
    cerr<<argv[0]<<": TUT execption cought: "<<ex.what()<<endl;
    return 1;
  }
  catch(...)
  {
    cerr<<argv[0]<<": unknown exception cought"<<endl;
    return 2;
  }

  return 0;
}

